let WhiteColor = {
	nsClass : "GXColor", 
	gxBrightness: 100,
	gxSaturation: 0,
	gxHue: 0,
}

let MenuBarMeterFill = {  
	nsClass : "GXColor",
	gxAlpha: 100,
	gxHue: 0,
	gxSaturation: 0, 
	"systemDark" : {  
		nsClass : "GXColor",
		gxBrightness: 100, 
		"highlighted" : {
			nsClass : "GXColor",
			gxBrightness: 100,
		}, 
	},
	"systemLight" : {
		nsClass : "GXColor",
		gxAlpha: 80, 
		gxBrightness: 0, 
		"highlighted" : {
			nsClass : "GXColor",
			gxBrightness: 100,
			gxAlpha: 100, 
		}, 
	}
}

markup.push({ 
	"StatusItemMarkup" : {
		nsClass: "GXStatusItem", 
		gxValueKeyPath: "",
        gxAutosaveName: "SSMainAppMenuIcon",
		gxChildViews : [
			{
				nsClass: "GXDrawView", 
				gxValueKeyPath: "",
				gxLayout: [ 
					"H:|-0-[VolumeIndicator(20)]-0-[LevelMeterHost]",
					"H:|-0-[TrialIcon(20)]-(>=0)-[LevelMeterHost]",
					"V:[VolumeIndicator]-(<=0)-[LegacyIcon]&alignCenterX",
					"V:|-0-[self(22)]-0-|",
					"H:|[self]|",
					"H:[LevelMeterHost]-0-|",
					"H:[CenterV]-(>=0)-[VolumeIndicator]&alignCenterY",
					"H:[CenterV]-(>=0)-[LegacyIcon]&alignCenterY",
					"H:[CenterV]-(>=0)-[TrialIcon]&alignCenterY",
					"V:|[topSpace]-0-[CenterV]-0-[bottomSpace(==topSpace)]|",
				],
				gxChildViews: {
					"VolumeIndicator" : {
						nsClass: "SoundSource.TCImageLayerView",
						gxValueKeyPath: "menuIcon",
						gxIntrinsicHeight: 20,
						gxShowOnKey: "showVolumeIndicator", 
						"gxSubLayers" : {
							"imageLayer" : {
								nsClass: "GXImageLayer", 
								gxFrameRect: "0,0,20,20",  
								gxForePainter: {
									nsClass : "GXImagePainter",
									gxTintColor: MenuBarMeterFill,
								},
							}
						},
					},
					"topSpace" : {
						nsClass: "GXDrawView",
					},
					"CenterV" : {
						nsClass: "GXDrawView",
						gxLayout : [
							"H:[self(1)]",
							"V:[self(1)]",
						],
					},
					"bottomSpace" : {
						nsClass: "GXDrawView",
					},
					"LevelMeterHost" : {
						gxLayout: [ 
							"V:|[self]|",
						],
						nsClass: GXDrawView,
						gxValueKeyPath: "",
						gxChildViews: {
							"LevelMeter" : {
								nsClass: "SoundSource.TCMenuLevelMeter",
								gxLayout: [
									"H:[self(8)]-0-|",
									"V:|-2-[self]-2-|"
								],
								gxValueKeyPath: "",
								gxViewFlipped: true, 
								gxVertical: true, 
								gxMinPeakHold: 0.2,  
								gxAnimateOnKey: "animateMeter", 
								gxClipValueKeyPath: "levelMeter.clipStereoMax",
								gxPeakValueKeyPath: "levelMeter.peakStereoMax",
								"gxRootLayer": {
									nsClass: "GXMeterLayer",  
									gxLayerZPosition: 2,
									gxFrameRect: "2,2,8,18",
									gxValueKeyPath: "",
									gxBackPainter: {
									   nsClass: "GXRoundRectPainter",
									   gxCornerRadius: 3,
									   gxFrameColor: MenuBarMeterFill, 
									}
								},   
								gxPeakLayer: { 
									nsClass: "GXMeterLayer",
									gxLayerZPosition: 2,
									gxFrameRect: "2,2,8,0", // Start out with no height
									gxValueKeyPath: "",
									gxBackPainter: { 
										nsClass: "GXRoundRectPainter",
										gxCornerRadii: "0,0,2,2",
										gxEdgeInsets: "1,3,1,1", // Inset meter fill at top, as the meter isn't rounded at this point and would overlap the bounds of the meterBack layer.
										gxFillColor:  MenuBarMeterFill, 
									},
									gxMaskLayer: {
										nsClass: "GXDrawLayer",
										"gxVertical": true,
										gxBackColor: "name:black",
										gxIsOpaque: true,
										gxLayerZPosition: 3,
									},	// sets layer color for fill
								},  
								gxPeakClipLayer: { 
									nsClass: "GXMeterLayer",
									gxLayerZPosition: 3,
									gxFrameRect: "2,2,8,4",
									gxValueKeyPath: "",
									gxOpacity: 0.0, // Start out hidden
									gxBackPainter: {
										nsClass: "GXRoundRectPainter",
										gxCornerRadii: "2,2,0,0",
										gxEdgeInsets: "1,1,1,0",
										gxFillColor: "name:red",
									},  
								},    
							},
						}
					}, 
					"TrialIcon" : {
						nsClass: "SoundSource.TCLayerHostingView", 
						gxShowOnKey: "safetyEnabled",
						gxLayout:["V:[self(17)]"],
						gxValueKeyPath: "",
						"gxSubLayers" : {
							"imageLayer" : {
								nsClass: "GXImageLayer",
								gxImage: "menu-icon.trial",
								gxFrameRect: "0,0,17,17",  
								gxForePainter: {
									nsClass: "GXImagePainter",
									gxTintColor: {
										nsClass: "GXColor",
										gxAlpha: 100,  
										gxHue: 48,
										gxSaturation: 80,
										gxBrightness: 100,
										"highlighted" : WhiteColor,
									},
								}
							}
						}
					},
					"LegacyIcon" : {
						nsClass: "SoundSource.TCLayerHostingView", 
						gxShowOnKey: "showLegacyIcon",
						gxIntrinsicWidth: 17, 
						gxIntrinsicHeight: 17,
						gxLayout:["V:[self(17)]"],
						gxValueKeyPath: "",
						"gxSubLayers" : {
							"imageLayer" : {
								nsClass: "GXImageLayer",
								gxImage: "menu-icon.logo", 
								gxFrameRect: "0,0,17,17",  
								gxForePainter: {
									nsClass: "GXImagePainter",
									gxTintColor: MenuBarMeterFill
								}
							}
						}
					}
				}
			}
		]
	}
})
